<?php

namespace Netim\Core
{
    use function Netim\netim\getUserLanguage;

    function GetDomainID(\Record $rec, string $domain)
    {
        $res = $rec->
        select(array('service_id'))->
        from('service_fields')->
        where("key", '=', "domain")->
        where("value", '=', $domain)->
        fetchall();

		if(!empty($res))
        	return $res[0]->service_id;
		else
			return false;
	}
	
	function getCountryCodes(\Record $rec): array
    {
        $res = $rec->
        select(array('alpha2', 'name', 'alt_name'))->
        from('countries')->
		fetchall();
		
		$array = array();

		foreach($res as $row)
		{
			$array[$row->alpha2] = $row->name . ($row->alt_name? " - " . $row->alt_name:"");
		}


        return $array;
	}
	
	function getStateCodes(\Record $rec): array
    {
        $res = $rec->
        select(array('country_alpha2', 'code', 'name'))->
        from('states')->
		fetchall();
		
		$array = array();

		foreach($res as $row)
		{
			if(!array_key_exists($row->country_alpha2, $array)) $array[$row->country_alpha2] = array();
			$array[$row->country_alpha2][$row->code] = $row->name;
		}

        return $array;
    }

   	function getAdditionalFields($tld)
	{
        if($tld[0]!='.')
            $tld = '.'.$tld;

		$json=file_get_contents(__DIR__ .DS.'..'. DS . 'additional_fields' . DS . 'additional_fields.json');
		$decoded_json=json_decode($json);

		if(isset($decoded_json->{$tld}))
			return $decoded_json->{$tld};
		else
			return false;
	}

	function translate($label,$user_lang="en")
    {
        $lang= explode("_",$user_lang);
        $translation="";
		$PATH=__DIR__ .DS.'..'. DS . 'additional_fields' . DS;

        // If the file exist for the full locale
        if(file_exists($PATH . $user_lang.'.inc.php'))
            include($PATH . $user_lang.'.inc.php');
        // If the file exist for the lang code    
        else if(file_exists($PATH . $lang[0].'.inc.php')) 
            include($PATH . $lang[0].'.inc.php');
        // Use english by default    
        else 
            include($PATH . 'en.inc.php');

        // Translate label to text    
        if(preg_match("#{{#",$label))
        {
            $temp=str_replace('{','',$label);
            $temp=str_replace('}','',$temp);
            if(isset($$temp))
                $translation=$$temp;
            else
                $translation = $label;
        }    
        else
            $translation = $label; 
    
		return $translation;	
    }
}